<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layoutadmin}">
<head>
    <meta charset="UTF-8">
    <title>Approval KRS</title>
</head>
<body>
<div layout:fragment="main">
    <div class="header bg-gradient-primary pb-8 pt-5 pt-md-8">
        <div class="container-fluid">
            <div class="header-body">
                <!-- Card stats -->
                <div class="row">
                    <div class="col-xl-12 col-lg-12">
                        <div class="card card-stats mb-4 mb-xl-0">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col">
                                        <h5 class="card-title text-uppercase text-muted mb-0">List</h5>
                                        <span class="h2 font-weight-bold mb-0">Request Konversi </span>
                                    </div>
                                    <div class="col-auto">
                                        <div class="icon icon-shape bg-gradient-blue text-white rounded-circle shadow">
                                            <i class="fas fa-calendar"></i>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-12" style="margin-top: 20px;">
                                <div class="row">
                                    <div class="col-md-5 mb--5">
                                        <select name="prodi" onchange="changeProdi(this.value)" id="prodi" class="form-control">
                                            <option value="-">Pilih Prodi</option>
                                            <option th:each="prodi : ${prodi}"
                                                    th:selected="(${prodi} == *{selectedProdi})"
                                                    th:text="${prodi.namaProdi}"
                                                    th:value="${prodi.id}"></option>
                                        </select>
                                    </div>
                                </div>
                                <div class="table-responsive">
                                    <table
                                            id="table-konversi"
                                            data-filter-control="true"
                                            data-search="true"
                                            data-show-refresh="true"
                                            data-flat="true"
                                            data-pagination="true"
                                            data-ajax="ajaxRequestKonversi"
                                            data-side-pagination="server">
                                    </table>

                                </div>
                            </div>

                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>
</body>
</html>
<link href="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/filter-control/bootstrap-table-filter-control.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/auto-refresh/bootstrap-table-auto-refresh.min.js"></script>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/izitoast/1.4.0/css/iziToast.min.css"
      integrity="sha512-O03ntXoVqaGUTAeAmvQ2YSzkCvclZEcPQu1eqloPaHfJ5RuNGiS4l+3duaidD801P50J28EHyonCV06CUlTSag=="
      crossorigin="anonymous" referrerpolicy="no-referrer"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/izitoast/1.4.0/js/iziToast.min.js"
        integrity="sha512-Zq9o+E00xhhR/7vJ49mxFNJ0KQw1E1TMWkPTxrWcnpfEFDEXgUiwJHIKit93EW/XxE31HSI5GEOW06G6BF1AtA=="
        crossorigin="anonymous" referrerpolicy="no-referrer"></script>
<script>
    var $tableKonversi = $('#table-konversi')

    $(function() {
        $tableKonversi.bootstrapTable({
            columns: [{
                field: 'nim',
                title : 'Mahasiswa',
                align: 'center',
                valign: 'middle',
                formatter: mahasiswaFormat
            }, {
                title: 'Prodi',
                field: 'prodi',
                align: 'center',
                valign: 'middle',
            }, {
                title: 'File Upload',
                field: 'prodi',
                align: 'center',
                valign: 'middle',
                formatter: fileFormat
            }, {
                title: 'Jenis Konversi',
                field: 'jenis',
                align: 'center',
                valign: 'middle',
                formatter: jenisFormat
            },{
                title: 'Aksi',
                field: 'status ',
                align: 'center',
                valign: 'middle',
                formatter: aksiFormat
            }]
        })
    })

    function ajaxRequestKonversi(params) {
        var url = '/api/get-data-konversi/tqc?prodiId=' + $('#prodi').val();
        $.get(url + '&' + $.param(params.data)).then(function (res) {
            params.success(res)
        })
    }

    function mahasiswaFormat(value, row, index) {
        return [
            row.nim + ' - ' + row.nama
        ].join('')
    }

    function jenisFormat(value, row, index) {
        return [
            '<div class="badge badge-info text-black">' + row.jenis +'</div>'
        ].join('')

    }

    function approvalFormat(value, row, index) {
        if (row.status == 'WAITING'){
            return [
                '<div class="badge badge-warning"> Menunggu Approval </div>'
            ].join('')
        }
        if (row.status == 'APPROVED'){
            return [
                '<div class="badge badge-info">  Tahfidz </div>'
            ].join('')
        }
    }

    function aksiFormat(value, row, index) {
        return [
            '<button class="btn btn-sm btn-success" data-mahasiswa="'+ row.nama +'" id="' + row.id + '" onclick="setuju(this)"> Setuju </button>',
            '<button class="btn btn-sm btn-danger" data-mahasiswa="'+ row.nama +'" id="' + row.id + '" onclick="tolak(this)"> Tolak </button>',
        ].join('')

    }

    function changeProdi(value) {
        $tableKonversi.bootstrapTable('refresh')
    }

    function fileFormat(value, row, index) {
        return [
            '<a target="_blank" href="/upload/' + row.id + '/konversi/" class="badge badge-info text-black"> Lihat File</a>'
        ].join('');
    }

    function setuju(args){
        var url = "/api/approval-konversi/" + args.id + "?approval=APPROVED_TQC";
        var token = $("input[name='_csrf']").val();

        Swal.fire({
            title: "Setujui Pendaftaran Konversi?",
            text: "Kamu akan mennyetujui pendaftaran konversi atas nama " + args.getAttribute('data-mahasiswa'),
            icon: "warning",
            showCancelButton: true,
            confirmButtonColor: "#3085d6",
            cancelButtonColor: "#d33",
            confirmButtonText: "Ya, Setujui!"
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: url,
                    contentType: "application/json;charset=UTF-8",
                    headers: {"X-CSRF-TOKEN": token},
                    method: 'post',
                    dataType: 'JSON',
                    success: function (data) {
                        $tableKonversi.bootstrapTable('refresh')
                        Swal.fire({
                            position: 'top-end',
                            title: "Disetujui!",
                            text: "Pendaftaran konversi atas nama " + args.getAttribute('data-mahasiswa') + " telah disetujui.",
                            icon: "success"
                        });
                    }
                })

            }
        });
    }

    function tolak(args){
        var url = "/api/rejected-konversi/" + args.id + "?approval=REJECTED_TQC";
        var token = $("input[name='_csrf']").val();

        Swal.fire({
            title: "Tolak Pendaftaran Konversi?",
            text: "Kamu akan menolak pendaftaran konversi atas nama " + args.getAttribute('data-mahasiswa'),
            icon: "warning",
            showCancelButton: true,
            confirmButtonColor: "#3085d6",
            cancelButtonColor: "#d33",
            confirmButtonText: "Ya, Tolak!"
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: url,
                    contentType: "application/json;charset=UTF-8",
                    headers: {"X-CSRF-TOKEN": token},
                    method: 'post',
                    dataType: 'JSON',
                    success: function (data) {
                        $tableKonversi.bootstrapTable('refresh')
                        Swal.fire({
                            position: 'top-end',
                            title: "Tertolak!",
                            text: "Pendaftaran konversi atas nama " + args.getAttribute('data-mahasiswa') + " telah ditolak.",
                            icon: "success"
                        });
                    }
                })
            }
        });
    }
</script>